Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions

# Clutter::Container Class Reference

Inherits Glib::Interface.

Inherited by Clutter::Box, and Clutter::Group.

Collaboration diagram for Clutter::Container:
[legend]

List of all members.

## Public Types
typedef sigc::slot< void, const Glib::RefPtr< Actor >& > | SlotForEach
| For instance, void on_foreach(const Glib::RefPtr<Actor>& actor).
## Public Member Functions
virtual | ~Container ()
ClutterContainer* | gobj ()
| Provides access to the underlying C GObject.
const ClutterContainer* | gobj () const
| Provides access to the underlying C GObject.
void | add_actor (const Glib::RefPtr< Actor >& actor)
| Adds a Clutter::Actor to container.
void | remove_actor (const Glib::RefPtr< Actor >& actor)
| Removes actor from container.
std::vector< Glib::RefPtr < Actor > > | get_children ()
std::vector< Glib::RefPtr < const Actor > > | get_children () const
void | lower_child (const Glib::RefPtr< Actor >& actor, const Glib::RefPtr< Actor >& sibling)
| Lowers actor to sibling level, in the depth ordering.
void | lower_child (const Glib::RefPtr< Actor >& actor)
void | raise_child (const Glib::RefPtr< Actor >& actor, const Glib::RefPtr< Actor >& sibling)
| Raises actor to sibling level, in the depth ordering.
void | raise_child (const Glib::RefPtr< Actor >& actor)
Glib::RefPtr< Actor > | find_child (const Glib::ustring& child_name)
| Finds a child actor of a container by its name.
Glib::RefPtr< const Actor > | find_child (const Glib::ustring& child_name) const
| Finds a child actor of a container by its name.
void | foreach (const SlotForEach& slot)
template<class PropertyType >
void | set_child_property (const Glib::RefPtr< Actor >& child, const Glib::ustring& property_name, const PropertyType&value)
void | set_child_property_value (const Glib::RefPtr< Actor >& child, const Glib::ustring& property_name, const Glib::ValueBase&value)
| Sets a container-specific property on a child of container.
template<class PropertyType >
void | get_child_property (const Glib::RefPtr< const Actor >& child, const Glib::ustring& property_name, PropertyType&value) const
void | get_child_property_value (const Glib::RefPtr< const Actor >& child, const Glib::ustring& property_name, Glib::ValueBase&value) const
Glib::RefPtr< ChildMeta > | get_child_meta (const Glib::RefPtr< const Actor >& actor)
| Retrieves the Clutter::ChildMeta which contains the data about the container specific state for actor.
Glib::RefPtr< const ChildMeta > | get_child_meta (const Glib::RefPtr< const Actor >& actor) const
| Retrieves the Clutter::ChildMeta which contains the data about the container specific state for actor.
Glib::SignalProxy1< void, const Glib::RefPtr< Actor >& > | signal_actor_added ()
Glib::SignalProxy1< void, const Glib::RefPtr< Actor >& > | signal_actor_removed ()
Glib::SignalProxy2< void, const Glib::RefPtr< Actor > &, GParamSpec* > | signal_child_notify ()
## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
## Protected Member Functions
void | sort_depth_order ()
| Sorts a container's children using their depth.
virtual void | add_vfunc (const Glib::RefPtr< Actor >& actor)
virtual void | remove_vfunc (const Glib::RefPtr< Actor >& actor)
virtual void | raise_vfunc (const Glib::RefPtr< Actor >& actor, const Glib::RefPtr< Actor >& sibling)
virtual void | lower_vfunc (const Glib::RefPtr< Actor >& actor, const Glib::RefPtr< Actor >& sibling)
virtual void | sort_depth_order_vfunc ()
virtual void | foreach_vfunc (ClutterCallback callback, gpointer user_data)
void | actor_added (const Glib::RefPtr< Actor >& actor)
| Emit signal_actor_added().
void | actor_removed (const Glib::RefPtr< Actor >& actor)
| Emit signal_actor_removed().
virtual void | create_child_meta_vfunc (const Glib::RefPtr< Actor >& actor)
virtual void | destroy_child_meta_vfunc (const Glib::RefPtr< Actor >& actor)
virtual Glib::RefPtr< ChildMeta > | get_child_meta_vfunc (const Glib::RefPtr< Actor >& actor)
virtual void | on_actor_added (const Glib::RefPtr< Actor >& actor)
virtual void | on_actor_removed (const Glib::RefPtr< Actor >& actor)
virtual void | on_child_notify (const Glib::RefPtr< Actor >& actor, GParamSpec* pspec)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Clutter::Container > | wrap (ClutterContainer* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Member Typedef Documentation

typedef sigc::slot<void, const Glib::RefPtr<Actor>&> Clutter::Container::SlotForEach

For instance, void on_foreach(const Glib::RefPtr<Actor>& actor).

## Constructor & Destructor Documentation

virtual Clutter::Container::~Container | ( |  | ) | `[virtual]`

## Member Function Documentation

void Clutter::Container::actor_added | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected]`

Emit signal_actor_added().

void Clutter::Container::actor_removed | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected]`

Emit signal_actor_removed().

void Clutter::Container::add_actor | ( | const Glib::RefPtr< Actor >& | actor | ) |

Adds a Clutter::Actor to container.

This function will emit the "actor-added" signal. The actor should be parented to container. You cannot add a Clutter::Actor to more than one Clutter::Container.

Since cluttermm 0.4:

Parameters:

  | actor | The first Clutter::Actor to add.

static void Clutter::Container::add_interface | ( | GType | gtype_implementer | ) | `[static]`

virtual void Clutter::Container::add_vfunc | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected, virtual]`

virtual void Clutter::Container::create_child_meta_vfunc | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected, virtual]`

virtual void Clutter::Container::destroy_child_meta_vfunc | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected, virtual]`

Glib::RefPtr<Actor> Clutter::Container::find_child | ( | const Glib::ustring & | child_name | ) |

Finds a child actor of a container by its name.

Search recurses into any child container.

Since cluttermm 0.6:

Parameters:

  | child_name | The name of the requested child.

Returns:
  The child actor with the requested name, or `0` if no actor with that name was found.

Glib::RefPtr<const Actor> Clutter::Container::find_child | ( | const Glib::ustring & | child_name | ) | const

Finds a child actor of a container by its name.

Search recurses into any child container.

Since cluttermm 0.6:

Parameters:

  | child_name | The name of the requested child.

Returns:
  The child actor with the requested name, or `0` if no actor with that name was found.

void Clutter::Container::foreach | ( | const SlotForEach & | slot | ) |

virtual void Clutter::Container::foreach_vfunc | ( | ClutterCallback | callback,
|  | gpointer | user_data |
| ) |  |  | `[protected, virtual]`

Glib::RefPtr<ChildMeta> Clutter::Container::get_child_meta | ( | const Glib::RefPtr< const Actor >& | actor | ) |

Retrieves the Clutter::ChildMeta which contains the data about the container specific state for actor.

Since cluttermm 0.8:

Parameters:

  | actor | A Clutter::Actor that is a child of container.

Returns:
  The Clutter::ChildMeta for the actor child of container or `0` if the specifiec actor does not exist or the container is not configured to provide Clutter::ChildMetas.

Glib::RefPtr<const ChildMeta> Clutter::Container::get_child_meta | ( | const Glib::RefPtr< const Actor >& | actor | ) | const

Retrieves the Clutter::ChildMeta which contains the data about the container specific state for actor.

Since cluttermm 0.8:

Parameters:

  | actor | A Clutter::Actor that is a child of container.

Returns:
  The Clutter::ChildMeta for the actor child of container or `0` if the specifiec actor does not exist or the container is not configured to provide Clutter::ChildMetas.

virtual Glib::RefPtr<ChildMeta> Clutter::Container::get_child_meta_vfunc | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected, virtual]`

template <class PropertyType >

void Clutter::Container::get_child_property | ( | const Glib::RefPtr< const Actor >& | child,
|  | const Glib::ustring & | property_name,
|  | PropertyType & | value |
| ) |  |  | const`[inline]`

void Clutter::Container::get_child_property_value | ( | const Glib::RefPtr< const Actor >& | child,
|  | const Glib::ustring & | property_name,
|  | Glib::ValueBase & | value |
| ) |  |  | const

std::vector<Glib::RefPtr<Actor> > Clutter::Container::get_children | ( |  | ) |

std::vector<Glib::RefPtr<const Actor> > Clutter::Container::get_children | ( |  | ) | const

ClutterContainer* Clutter::Container::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Clutter::Box, Clutter::Group, and Clutter::Stage.

const ClutterContainer* Clutter::Container::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Clutter::Box, Clutter::Group, and Clutter::Stage.

void Clutter::Container::lower_child | ( | const Glib::RefPtr< Actor >& | actor,
|  | const Glib::RefPtr< Actor >& | sibling |
| ) |  |  |

Lowers actor to sibling level, in the depth ordering.

Since cluttermm 0.6:

Parameters:

  | actor | The actor to raise.
  | sibling | The sibling to lower to, or `0` to lower to the bottom.

void Clutter::Container::lower_child | ( | const Glib::RefPtr< Actor >& | actor | ) |

virtual void Clutter::Container::lower_vfunc | ( | const Glib::RefPtr< Actor >& | actor,
|  | const Glib::RefPtr< Actor >& | sibling |
| ) |  |  | `[protected, virtual]`

virtual void Clutter::Container::on_actor_added | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected, virtual]`

virtual void Clutter::Container::on_actor_removed | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected, virtual]`

virtual void Clutter::Container::on_child_notify | ( | const Glib::RefPtr< Actor >& | actor,
|  | GParamSpec * | pspec |
| ) |  |  | `[protected, virtual]`

void Clutter::Container::raise_child | ( | const Glib::RefPtr< Actor >& | actor,
|  | const Glib::RefPtr< Actor >& | sibling |
| ) |  |  |

Raises actor to sibling level, in the depth ordering.

Since cluttermm 0.6:

Parameters:

  | actor | The actor to raise.
  | sibling | The sibling to raise to, or `0` to raise to the top.

void Clutter::Container::raise_child | ( | const Glib::RefPtr< Actor >& | actor | ) |

virtual void Clutter::Container::raise_vfunc | ( | const Glib::RefPtr< Actor >& | actor,
|  | const Glib::RefPtr< Actor >& | sibling |
| ) |  |  | `[protected, virtual]`

void Clutter::Container::remove_actor | ( | const Glib::RefPtr< Actor >& | actor | ) |

Removes actor from container.

The actor should be unparented, so if you want to keep it around you must hold a reference to it yourself, using Glib::object_ref(). When the actor has been removed, the "actor-removed" signal is emitted by container.

Since cluttermm 0.4:

Parameters:

  | actor | A Clutter::Actor.

virtual void Clutter::Container::remove_vfunc | ( | const Glib::RefPtr< Actor >& | actor | ) | `[protected, virtual]`

template <class PropertyType >

void Clutter::Container::set_child_property | ( | const Glib::RefPtr< Actor >& | child,
|  | const Glib::ustring & | property_name,
|  | const PropertyType & | value |
| ) |  |  | `[inline]`

void Clutter::Container::set_child_property_value | ( | const Glib::RefPtr< Actor >& | child,
|  | const Glib::ustring & | property_name,
|  | const Glib::ValueBase & | value |
| ) |  |  |

Sets a container-specific property on a child of container.

Since cluttermm 0.8:

Parameters:

  | child | A Clutter::Actor that is a child of container.
  | property | The name of the property to set.
  | value | The value.

Glib::SignalProxy1< void,const Glib::RefPtr<Actor>& > Clutter::Container::signal_actor_added | ( |  | ) |

Prototype:
  `void on_my_actor_added(const Glib::RefPtr<Actor>& actor)`

Glib::SignalProxy1< void,const Glib::RefPtr<Actor>& > Clutter::Container::signal_actor_removed | ( |  | ) |

Prototype:
  `void on_my_actor_removed(const Glib::RefPtr<Actor>& actor)`

Glib::SignalProxy2< void,const Glib::RefPtr<Actor>&,GParamSpec* > Clutter::Container::signal_child_notify | ( |  | ) |

Prototype:
  `void on_my_child_notify(const Glib::RefPtr<Actor>& actor, GParamSpec* pspec)`

void Clutter::Container::sort_depth_order | ( |  | ) | `[protected]`

Sorts a container's children using their depth.

This function should not be normally used by applications.

Since cluttermm 0.6:

virtual void Clutter::Container::sort_depth_order_vfunc | ( |  | ) | `[protected, virtual]`

## Friends And Related Function Documentation

Glib::RefPtr< Clutter::Container > wrap | ( | ClutterContainer * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- cluttermm/container.h